package bensley.fatcontroller;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.content.pm.ResolveInfo;
import android.os.Bundle;
import android.speech.RecognizerIntent;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class FatController extends Activity {
    
	EditText TXT_IP;
	EditText TXT_PORT;
	Button BTN_CONNECT;
    Button BTN_LISTEN;
    ListView mList;
    static TCPSocket TCP_SOCKET;
    private static final int VOICE_RECOGNITION_REQUEST_CODE = 1234;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        TXT_IP = (EditText)this.findViewById(R.id.txtIP);
        TXT_PORT = (EditText)this.findViewById(R.id.txtPort);

        BTN_CONNECT = (Button)this.findViewById(R.id.btnConnect);
        BTN_CONNECT.setOnClickListener(new Button.OnClickListener() {public void onClick(View v) {connect();} });
        BTN_LISTEN = (Button)this.findViewById(R.id.btn_speak);
        BTN_LISTEN.setOnClickListener(new Button.OnClickListener() {public void onClick(View v) {listen();} });
        
        mList = (ListView) findViewById(R.id.list);

        //Check to see if a recognition activity is present
        PackageManager pm = getPackageManager();
        List<ResolveInfo> activities = pm.queryIntentActivities(new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH), 0);
        if (activities.size() == 0) {
        	//Toast.makeText(this, "good", Toast.LENGTH_SHORT).show();
        //} else {
        	Toast.makeText(this, "No speech recognition package found :(", Toast.LENGTH_SHORT).show();
        }
        
    }
    
    public void connect(){
        //This method is called when the "Connect" button calls its onClick method;
    	if(BTN_CONNECT.getText().equals("Connect")){
        	//Using our TCPSocket class, call its "sckConnect" method to connect to the supplied IP & port
        	TCPSocket.strServerIP = TXT_IP.getText().toString();
        	TCPSocket.intServerPort = Integer.parseInt(TXT_PORT.getText().toString());
        	if(!TCPSocket.bolEstablished) {
            	TCP_SOCKET = new TCPSocket();
            	TCP_SOCKET.start();
            }
            BTN_CONNECT.setText("Disconnect");
    	}else if(BTN_CONNECT.getText().equals("Disconnect")){
        	//Call the disconnect method on our socket class
    		TCP_SOCKET.Disconnect();
    		BTN_CONNECT.setText("Connect");
    	}
    }
    
    public void listen(){
    	startVoiceRecognitionActivity();
    }
   
    /**
     * Fire an intent to start the speech recognition activity.
     */
    private void startVoiceRecognitionActivity() {
        Intent intent = new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
    //    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,
    //    RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);
    //    intent.putExtra(RecognizerIntent.EXTRA_PROMPT, "Speech recognition demo");
        startActivityForResult(intent, VOICE_RECOGNITION_REQUEST_CODE);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == VOICE_RECOGNITION_REQUEST_CODE && resultCode == RESULT_OK) {
            // Fill the list view with the strings the recogniser thought it could have heard
            ArrayList<String> matches = data.getStringArrayListExtra(
                    RecognizerIntent.EXTRA_RESULTS);
            mList.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1,
                    matches));
            mList.setClickable(true);
            mList.setOnItemClickListener(new OnItemClickListener() {
            	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
           		 TCPSocket.strTCPData = ((TextView) view).getText().toString();
                 TCPSNotify();
                }
            	 });
            TCPSocket.strTCPData = String.valueOf(mList.getItemAtPosition(0));
            TCPSNotify();
        }

     //   super.onActivityResult(requestCode, resultCode, data);
    }
    
    public static void TCPSNotify() {
    	if(TCPSocket.bolEstablished) {
    		TCPSocket.bolNewData = true;
    		synchronized (TCP_SOCKET) {
    			TCP_SOCKET.notify();
    		}
    	}
    }
    
}