package bensley.fatcontroller;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.UnknownHostException;
import java.net.Socket;

import android.util.Log;

public class TCPSocket extends Thread {

	// This class extends a thread implementation, used as a separate thread from the main UI thread
	// in which to send the TCP data. 
	
	static String strServerIP;
    static Integer intServerPort;
    Socket sckClient = null;
    public static Boolean bolEstablished = false;
    public static String strTCPData;
    public static Boolean bolNewData = false;
    PrintWriter out = null; 
	
    public void run()
    {
    	// When the main run method of the thread is executed we start by creating a new Socket object and connect to the remote host
    	try {
    		sckClient = new Socket(strServerIP, intServerPort);
    		bolEstablished = true;
    	} catch (UnknownHostException e) {
    		Log.d("Socket UnknownHostException: ", strServerIP + ":" + intServerPort);
    	} catch (IOException e) {
    		Log.d("Socket IOExpection: ", String.valueOf(e));
    	}

    	// The bolEstablished boolean is set to true and this forms our main method loop to send the TCP data
    	
    	while(bolEstablished) {
           synchronized(this) {
        	   // We synchronise this thread; now we are inside the bolEstablished loop and within here we are checking the bolNewData boolean
        	   // if this is true, new data is waiting to be sent, so we try and sent it
                if(bolNewData) {
                	try {
                		out = new PrintWriter( new BufferedWriter( new OutputStreamWriter(sckClient.getOutputStream())),true);
                	} catch (IOException e) {
                		Log.d("PrintWriter IOException: ", String.valueOf(e));
                		e.printStackTrace();
                	}
                	//Log.d("sending: ", strTCPData);
                	out.printf("%s", strTCPData);
                	// If any data was sent then reset the boolean
                  	bolNewData = false;
                } else {
                	// Now that any data that needed sending has been sent or if there simply was no data in the first place we call wait()
                	// This thread will wait() for a notify from a synchronised handler
                	// Any time Input sends a notify to this thread it shall wake, and go round the loop again sending and data any then go back to sleep
                	try {
                		wait();
                	} catch (InterruptedException e) {
                		e.printStackTrace();
                	}
                } // NewData IF
            } // Synchronised
        } // While(bolEstablished)
    } // void run
    
    public void Disconnect() {
    	// There isn't a graceful way of 'killing' a thread, so instead we call this disconnect method;
    	// Here we gracefully disconnect the socket object and set bolEstablished to false, now the above infinite loop in the main run() 
    	// method will drop out and we will execute down to the end of the run() method and gracefully end the thread's run that way
    	if(bolEstablished) {
    		try {
    			sckClient.close();
    			bolEstablished = false;
    		} catch (IOException e) {
    			Log.d("Socket Close IOException: ", String.valueOf(e));
    		}
    	}
    }

}
